EnableExplicit
Structure PREFS
   UdapteDate.i
   
   Commas.b
   Colons.b
   Comparisons.b
   Equals.b
   
   UseThickerCaret.b
   UseCommentHelper.b
   UseWordHighlighting.b
   CommentBarLength.i
   HighlightColor.i
EndStructure
Structure SHAREDINFO
   File$
   Name$   
   *HandleMap
   StructureUnion
      *MemoryMap
      *Preferences.PREFS
   EndStructureUnion       
EndStructure
Structure PARAMS
   SharedConfig.SHAREDINFO
   *Ide
   *Sci
   *Tool
   *Dll
   *WndProc
   *Hook
   
   Find.SCTextToFind
   Range.SCTextRange
   
   CursorPos.i
   CursorLine.i
   Line.i
   LineIndentPos.i
   LineStartPos.i
   LineEndPos.i
   FirstLine.i
   LastLine.i
   
   InsertLines.i
   InsertPos.i
   
   Original$
   StartPos.i
   EndPos.i
   CharAdded.i
   WordCount.i
   
   Map NextIndent.i()
   Map PrevIndent.i()
   LastIndentedLine.i
   PrevLineIndent.i
   NextLineIndent.i
   LineIndent.i
   BrokenIndent.i
   BrokenStartIndent.i
   IsBrokenLine.b
   IsBrokenStartLine.b
EndStructure
Global App.PARAMS

CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Enumeration
      ;beautification modes
      #Beautify_CurrentLine=%1
      #Beautify_PreviousLines=%10
      #Beautify_Comments=%100
      #Beautify_Indentation=%1000
      
      ;auto actions
      #Auto_PositionCursor=%1
      #Auto_Format=%10
      #Auto_TrimSpaces=%100
      #Auto_Indent=%1000
      
      ;find lines
      #Find_CurrentLine=%1
      #Find_ClosestVisibleLines=%10
      #Find_LastInsertedLines=%100
      #Find_OnlyPreviousLine=%1000
      #Find_BrokenLines=#Find_ClosestVisibleLines|
                        #Find_LastInsertedLines|
                        #Find_OnlyPreviousLine
      
      ;replace special
      #Replace_Dot=0
      #Replace_Spaces
      #Replace_Empty
      
      ;character codes
      #RETURN=10
      #SPACE=32
      #DoubleQuote=34
      #SingleQuote=39
   EndEnumeration
   
   ImportC""
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
         pcre_exec.l(*pcre, *extra, subject.s, length, startoffset, options, *ovector, ovecsize) As "pb_pcre_exec"
      CompilerElse
         pcre_exec.l(*pcre, *extra, subject.s, length, startoffset, options, *ovector, ovecsize) As "_pb_pcre_exec"
      CompilerEndIf
   EndImport
   
   Procedure Logger(msg.s)
      CompilerIf 1
         OpenFile(0, "D:\PORTABLE\PureBasic\Projects\PB_editor_extensions\test.txt", #PB_File_Append)
         WriteStringN(0, FormatDate("%ii:%ss ", Date())+ msg)
         CloseFile(0)
      CompilerEndIf
   EndProcedure
   Procedure.s ReplaceRegexSpecial(RegularExpression, string.s, mode)
      Static Dim found$(0)
      Protected start=1, replacement$
      While ExtractRegularExpression(RegularExpression, Mid(string, start), found$())
         start=FindString(string, found$(0), start)
         Select mode
            Case #Replace_Dot
               replacement$=RSet("", Len(found$(0)), ".")
            Case #Replace_Spaces
               replacement$=Space(Len(found$(0)))
            Case #Replace_Empty
               replacement$=""
         EndSelect
         string=ReplaceString(string, found$(0), replacement$, #PB_String_CaseSensitive, start)
         start+Len(replacement$)
      Wend
      ProcedureReturn string
   EndProcedure
   Procedure.s ReplaceRegexBackReferences(RegularExpression, string.s, replacement.s)
      Static Dim pcre_results.l(10, 1)
      Protected start = 0, ref = 0
      Repeat
         Protected res.l = pcre_exec(PeekI(RegularExpression), 0, string, Len(string), start, 0, @pcre_results(), 20)
         If res=-1 : Break : EndIf
         
         Protected rpl.s = replacement
         Protected p = pcre_results(0, 0)
         Protected q = pcre_results(0, 1)
         
         ;backreference = \0 .... \9
         If FindString(replacement, "\0", 1)
            rpl = ReplaceString(rpl, "\0", PeekS(@string + p, q-p))
         EndIf
         For ref = 1 To 9
            Protected tag$ ="\" + ref
            If FindString(replacement, tag$, 1)
               Protected p1 = pcre_results(ref, 0)
               Protected q1 = pcre_results(ref, 1)
               rpl = ReplaceString(rpl, tag$, PeekS(@string + p1, q1-p1))
            EndIf
         Next
         
         start = p + Len(rpl)
         string = Left(string, p)+ rpl + Right(string, Len(string)-q)
      ForEver
      ProcedureReturn string
   EndProcedure
   Procedure.i Sci(Message, wParam=0, lParam=0)
      ProcedureReturn SendMessage_(App\Sci, Message, wParam, lParam)
   EndProcedure
   Procedure.i SciTextMemory(text$)
      Protected *textUTF8 = AllocateMemory(StringByteLength(text$, #PB_UTF8)+1)
      If *textUTF8
         PokeS(*textUTF8, text$, -1, #PB_UTF8)
         ProcedureReturn *textUTF8
      EndIf
   EndProcedure
   Procedure.s SciReadText(startPos=#PB_Ignore, endPos=#PB_Ignore)
      With App
         If startPos=#PB_Ignore And endPos=#PB_Ignore
            startPos=\Find\chrgText\cpMin
            endPos=\Find\chrgText\cpMax
         ElseIf endPos=#PB_Ignore
            Protected line=startPos
            startPos=Sci(#SCI_POSITIONFROMLINE, line)
            endPos=Sci(#SCI_GETLINEENDPOSITION, line)
         EndIf
         Protected textLength
         Protected text$, *textUTF8
         textLength = endPos-startPos
         If textLength
            *textUTF8 = AllocateMemory(textLength+1)
            If *textUTF8
               \Range\lpstrText=*textUTF8
               \Range\chrg\cpMin=startPos
               \Range\chrg\cpMax=endPos
               Sci(#SCI_GETTEXTRANGE, 0, \Range)
               text$ = PeekS(*textUTF8, textLength, #PB_UTF8)
               FreeMemory(*textUTF8)
               ProcedureReturn text$
            EndIf
         EndIf
      EndWith
   EndProcedure
   Procedure.b SciFindRegex(regex$, startPos=#PB_Ignore, endPos=#PB_Ignore)
      With App
         If startPos=#PB_Ignore And endPos=#PB_Ignore
            startPos=\Find\chrgText\cpMin
            endPos=\Find\chrgText\cpMax
         ElseIf endPos=#PB_Ignore
            Protected line=startPos
            startPos=Sci(#SCI_POSITIONFROMLINE, line)
            endPos=Sci(#SCI_GETLINEENDPOSITION, line)
         EndIf
         If startPos<endPos
            \Find\chrg\cpMin=startPos
            \Find\chrg\cpMax=endPos
            \Find\lpstrText=@regex$
            ProcedureReturn Bool(Sci(#SCI_FINDTEXT, #SCFIND_REGEXP|#SCFIND_POSIX, \Find)>-1)
         EndIf
      EndWith
   EndProcedure
   Procedure.b SciFindText(text$, startPos=#PB_Ignore, endPos=#PB_Ignore, wholeWord.b=#True, matchCase.b=#False)
      With App
         If startPos=#PB_Ignore And endPos=#PB_Ignore
            startPos=\Find\chrgText\cpMin
            endPos=\Find\chrgText\cpMax
         ElseIf endPos=#PB_Ignore
            Protected line=startPos
            startPos=Sci(#SCI_POSITIONFROMLINE, line)
            endPos=Sci(#SCI_GETLINEENDPOSITION, line)
         EndIf
         If startPos<endPos
            \Find\chrg\cpMin=startPos
            \Find\chrg\cpMax=endPos
            \Find\lpstrText=@text$
            Protected flags=0
            If wholeWord : flags | #SCFIND_WHOLEWORD : EndIf
            If matchCase : flags | #SCFIND_MATCHCASE : EndIf
            ProcedureReturn Bool(Sci(#SCI_FINDTEXT, flags, \Find)>-1)
         EndIf
      EndWith
   EndProcedure
   Procedure.s SciExtractBackReferences(index)
      With App
         Protected textLength=\find\chrgText\cpMax-\find\chrgText\cpMin
         Protected *textUTF8 = AllocateMemory(textLength)
         Protected tag$
         If *textUTF8
            SCi(#SCI_GETTAG, 1, *textUTF8)
            tag$ = PeekS(*textUTF8, textLength, #PB_UTF8)
            FreeMemory(*textUTF8)
            ProcedureReturn tag$
         EndIf
      EndWith
   EndProcedure
   Procedure.s SciExtractRegex(regex$, startPos=#PB_Ignore, endPos=#PB_Ignore)
      With App
         If SciFindRegex(regex$, startPos, endPos)
            ProcedureReturn SciReadText(\Find\chrgText\cpMin, \Find\chrgText\cpMax)
         EndIf
      EndWith
   EndProcedure
   Procedure.i SciReplaceRegex(regex$, startPos=#PB_Ignore, endPos=#PB_Ignore)
      With App
         Protected *txt=SciTextMemory(regex$)
         If *txt
            If startPos=#PB_Ignore And endPos=#PB_Ignore
               startPos=\Find\chrgText\cpMin
               endPos=\Find\chrgText\cpMax
            ElseIf endPos=#PB_Ignore
               Protected line=startPos
               startPos=Sci(#SCI_POSITIONFROMLINE, line)
               endPos=Sci(#SCI_GETLINEENDPOSITION, line)
            EndIf
            Sci(#SCI_SETTARGETSTART, startPos)
            Sci(#SCI_SETTARGETEND, endPos)
            Sci(#SCI_REPLACETARGETRE, -1, *txt)
            FreeMemory(*txt)
            ;retrieve count of added or removed characters
            ProcedureReturn(Sci(#SCI_GETTARGETEND)-Sci(#SCI_GETTARGETSTART))-(endPos-startPos)
         EndIf
      EndWith
   EndProcedure
   Procedure.i SciReplaceText(text$, startPos=#PB_Ignore, endPos=#PB_Ignore)
      With App
         Protected *txt=SciTextMemory(text$)
         If *txt
            If startPos=#PB_Ignore And endPos=#PB_Ignore
               startPos=\Find\chrgText\cpMin
               endPos=\Find\chrgText\cpMax
            ElseIf endPos=#PB_Ignore
               Protected line=startPos
               startPos=Sci(#SCI_POSITIONFROMLINE, line)
               endPos=Sci(#SCI_GETLINEENDPOSITION, line)
            EndIf
            Sci(#SCI_SETTARGETSTART, startPos)
            Sci(#SCI_SETTARGETEND, endPos)
            Sci(#SCI_REPLACETARGET, -1, *txt)
            FreeMemory(*txt)
            ;retrieve count of added or removed characters
            ProcedureReturn(Sci(#SCI_GETTARGETEND)-Sci(#SCI_GETTARGETSTART))-(endPos-startPos)
         EndIf
      EndWith
   EndProcedure
   
   Procedure SciCurrentLine(currentLine)
      With App
         \Line=currentLine
         \LineStartPos=Sci(#SCI_POSITIONFROMLINE, \Line)
         \LineEndPos=Sci(#SCI_GETLINEENDPOSITION, \Line)
         \LineIndentPos=Sci(#SCI_GETLINEINDENTPOSITION, \Line)
         \PrevLineIndent=0
         \NextLineIndent=0
      EndWith
   EndProcedure
   Procedure SciAutoComment()
      With App
         #REGEX_CommentBar$="^\s*;\s*[-=*]+[ ]*$"
         #REGEX_CommentStart$="^\s*;\s*"
         
         If SciFindRegex(#REGEX_CommentBar$, \Line-1) And
            Not SciFindRegex(#REGEX_CommentStart$, \Line-2) And
            Not SciFindRegex(#REGEX_CommentStart$, \Line+1)
            ; ******************************
            ; add comment bars
            ; ******************************
            Protected CommentBar$=RTrim(SciReadText(\Line-1))
            Protected CommentStart$=SciExtractRegex(#REGEX_CommentStart$, \Line-1)
            Protected commentChar$=Mid(CommentBar$, Len(CommentBar$))
            Protected commentBarLength=Len(CommentBar$)-Len(CommentStart$)
            If commentBarLength<\SharedConfig\Preferences\CommentBarLength 
               commentBarLength=\SharedConfig\Preferences\CommentBarLength 
            EndIf
            CommentBar$=LSet(CommentStart$, Len(CommentStart$)+commentBarLength, commentChar$)
            SciReplaceText(CommentStart$+#LF$+CommentBar$, \Line)
            \CursorPos=\LineStartPos+Len(CommentStart$)
            Sci(#SCI_GOTOPOS, \CursorPos)
            SciReplaceText(CommentBar$, \Line-1)
            
         ElseIf SciFindRegex(#REGEX_CommentStart$, \Line-1) And
                SciFindRegex(#REGEX_CommentStart$, \Line+1)
            ; ******************************
            ; extend comment block
            ; ******************************
            CommentStart$=SciExtractRegex(#REGEX_CommentStart$, \Line-1)
            SciReplaceText(CommentStart$, \LineStartPos, \CursorPos)
            \CursorPos=\LineStartPos+Len(CommentStart$)
            Sci(#SCI_GOTOPOS, \CursorPos)
         EndIf
      EndWith
   EndProcedure
   Procedure SciAutoIndent()
      With App
         If \IsBrokenLine
            ; ******************************
            ; indent broken line
            ; ******************************
            Sci(#SCI_SETLINEINDENTATION, \Line, \BrokenIndent)
            \LineIndent+(\PrevLineIndent+\NextLineIndent)
            \CharAdded=SCi(#SCI_GETLINEINDENTPOSITION, \Line)-\LineIndentPos
         Else
            ; ******************************
            ; indent common line
            ; ******************************
            If \Line>\FirstLine
               Protected lineIndentation=Sci(#SCI_GETLINEINDENTATION, \LastIndentedLine)+(\PrevLineIndent+\LineIndent)*Sci(#SCI_GETTABWIDTH)
               Sci(#SCI_SETLINEINDENTATION, \Line, lineIndentation)
               \CharAdded=SCi(#SCI_GETLINEINDENTPOSITION, \Line)-\LineIndentPos
            EndIf
            \LineIndent=\NextLineIndent
            \LastIndentedLine=\Line
         EndIf
         If \IsBrokenStartLine
            ; ******************************
            ; calculation of next broken line indentation
            ; ******************************
            \IsBrokenStartLine=0
            \BrokenStartIndent+Sci(#SCI_GETLINEINDENTATION, \Line)
         EndIf
      EndWith
   EndProcedure
   Procedure SciAutoTrimSpaces()
      With App
         If SciFindRegex("\s+$", \Line)
            ; ******************************
            ; remove trailing end spaces
            ; ******************************
            If \Find\chrgText\cpMin>\LineStartPos
               SciReplaceText("")
            EndIf
         EndIf
      EndWith
   EndProcedure
   Procedure SciAutoFormat()
      With App
         ; ******************************
         ; format code
         ; ******************************
         Static regexComma, regexBracket1, regexBracket2, regexColon
         Static regexLogicOp, regexLogicOp2, regexType, regexSpaces
         If regexComma=0
            regexSpaces=CreateRegularExpression(#PB_Any, "\s{2,}(?![;\s])")
            regexBracket1=CreateRegularExpression(#PB_Any, "\s*\(\s*")
            regexBracket2=CreateRegularExpression(#PB_Any, "\s*\)\s*(?![;\s])|\s*\)")
            regexComma=CreateRegularExpression(#PB_Any, "\s*,\s*")
            regexColon=CreateRegularExpression(#PB_Any, "\s*:\s*")
            regexLogicOp=CreateRegularExpression(#PB_Any, "\s*\b(And|Or|Xor|As)\b\s*")
            regexLogicOp2=CreateRegularExpression(#PB_Any, "\b(If|Not)\b\s*")
            regexType=CreateRegularExpression(#PB_Any, "(\w+)\b\s*\.\s*\b(\w+)\b")
         EndIf
         
         Protected formatted$=\Original$
         formatted$=ReplaceRegularExpression(regexSpaces, formatted$, " ")
         formatted$=ReplaceRegularExpression(regexBracket1, formatted$, "(")
         formatted$=ReplaceRegularExpression(regexBracket2, formatted$, ")")
         formatted$=ReplaceRegularExpression(regexComma, formatted$, ", ")
         formatted$=ReplaceRegularExpression(regexColon, formatted$, " : ")
         formatted$=ReplaceRegexBackReferences(regexLogicOp, formatted$, " \1 ")
         formatted$=ReplaceRegexBackReferences(regexLogicOp2, formatted$, "\1 ")
         formatted$=ReplaceRegexBackReferences(regexType, formatted$, "\1.\2")
         If \StartPos=\LineIndentPos
            formatted$=LTrim(formatted$)
         EndIf
         If \Line<>\CursorLine And \find\chrgText\cpMax=\LineEndPos
            formatted$=RTrim(formatted$)
         EndIf
         If formatted$<>\Original$
            \CharAdded=SciReplaceText(formatted$)
         EndIf
      EndWith
   EndProcedure
   Procedure SciParseWords()
      With App
         ; ******************************
         ; parse line to find keywords
         ; ******************************
         Static regexWords, regexCleanup
         Protected keyword$, prevIndentValue, nextIndentValue, i
         If regexWords=0
            regexWords=CreateRegularExpression(#PB_Any, "(?<![#*\\])\b\w{2,}\b")
            regexCleanup=CreateRegularExpression(#PB_Any, "("+#DQUOTE$+")[^"+#DQUOTE$+"]*|(;[^\w\s]*).*")
            DataSection
               Data.s"[INDENT]"
               Data.i 0, 1
               Data.s"If", "CompilerIf"
               Data.s"For", "ForEach", "While", "Repeat"
               Data.s"Procedure", "ProcedureC", "ProcedureCDLL", "ProcedureDLL"
               Data.s"Macro", "With", "Import", "ImportC", "DataSection"
               Data.s"Structure", "StructureUnion", "Interface", "Enumeration"
               
               Data.s"[INDENT]"
               Data.i -1, 0
               Data.s"EndIf", "CompilerEndIf"
               Data.s"Next", "Wend", "Until", "ForEver"
               Data.s"EndProcedure"
               Data.s"EndMacro", "EndWith", "EndImport", "EndDataSection"
               Data.s"EndStructure", "EndStructureUnion", "EndInterface", "EndEnumeration"
               
               Data.s"[INDENT]"
               Data.i -1, 1
               Data.s"Else", "ElseIf", "CompilerElse", "CompilerElseIf"
               Data.s"Case", "Default", "CompilerCase", "CompilerDefault"
               
               Data.s"[INDENT]"
               Data.i 0, 2
               Data.s"Select", "CompilerSelect"
               
               Data.s"[INDENT]"
               Data.i -2, 0
               Data.s"EndSelect", "CompilerEndSelect"
               
               Data.s"[END]"
            EndDataSection
            Repeat
               Read.s keyword$
               If keyword$="[END]"
                  Break
               ElseIf keyword$="[INDENT]"
                  Read.i prevIndentValue
                  Read.i nextIndentValue
               Else
                  keyword$=LCase(keyword$)
                  \PrevIndent(keyword$)=prevIndentValue
                  \NextIndent(keyword$)=nextIndentValue
               EndIf
            ForEver
         EndIf
         
         Protected Dim word$(0), word$
         \Original$=ReplaceRegexBackReferences(regexCleanup, \Original$, "\1")
         If ExtractRegularExpression(regexWords, \Original$, word$())
            For i=0 To ArraySize(word$())
               word$=LCase(word$(i))
               \WordCount+1
               If \WordCount=1
                  \PrevLineIndent+\PrevIndent(word$)
                  \NextLineIndent+\NextIndent(word$)
               Else
                  \NextLineIndent+\PrevIndent(word$)+\NextIndent(word$)
               EndIf
            Next
         EndIf
      EndWith
   EndProcedure
   Procedure SciParseLineBreakers()
      With App
         ; ******************************
         ; parse line end to find line breaker
         ; ******************************
         Protected pos, openBracket, isBrokenPos.b, isBrokenParams.b
         Protected brokenLine$, brokenExprPos, isBrokenExpr.b
         Protected Dim brokenLine$(0)
         
         If \BrokenStartIndent
            \BrokenIndent=\BrokenStartIndent
            \IsBrokenLine=1
         Else
            \BrokenIndent=0
            \IsBrokenLine=0
         EndIf
         If Not SciFindRegex(";.+$", \Line) And
            (SciFindRegex("([,+|])\s*$", \Line) Or
             SciFindRegex("\<(and)\>\s*$", \Line) Or
             SciFindRegex("\<(x?or)\>\s*$", \Line))
            brokenLine$=LCase(SciExtractBackReferences(1))
            
            isBrokenParams =FindString(brokenLine$, ",")
            isBrokenExpr=Bool(FindString(brokenLine$, "or") Or FindString(brokenLine$, "and"))
            If isBrokenExpr And SciFindRegex("^\s*(\w+)", \Line) And \NextIndent(LCase(SciExtractBackReferences(1)))>0
               brokenExprPos=\Find\chrgText\cpMax-1
            Else
               brokenExprPos=-1
            EndIf
            For pos=\LineEndPos To \LineIndentPos Step -1
               Protected char.u=SCi(#SCI_GETCHARAT, pos)
               If char=#DoubleQuote Or char=#SingleQuote
                  Repeat : pos-1 : Until pos<=\LineIndentPos Or SCi(#SCI_GETCHARAT, pos)=char
               ElseIf char='('
                  openBracket+1
                  isBrokenPos=Bool(openBracket>0)
               ElseIf char=')'
                  openBracket-1
               ElseIf Not isBrokenParams And openBracket=0
                  Select char
                     Case':'
                        isBrokenPos=1
                     Case'=', ','
                        isBrokenPos=Bool(Not isBrokenExpr)
                     Case'a' To'z', 'A' To'Z'
                        isBrokenPos=Bool(isBrokenExpr And pos=brokenExprPos)
                  EndSelect
               EndIf
               If isBrokenPos And SciFindRegex(".\s*", pos, \LineEndPos)
                  \BrokenStartIndent=\find\chrgText\cpMax-\LineIndentPos
                  \IsBrokenStartLine=1
                  Break
               EndIf
            Next
         Else
            \BrokenStartIndent=0
         EndIf
      EndWith
   EndProcedure
   Procedure SciParse(auto)
      With App
         If auto & #Auto_PositionCursor
            \LineEndPos=\CursorPos
         EndIf
         
         \StartPos=\LineIndentPos
         \EndPos=\LineEndPos
         While SciFindRegex("[^"+#DQUOTE$+"';]*", \StartPos, \EndPos)
            Protected nextPos=\Find\chrgText\cpMax
            Protected nextChar.u=Sci(#SCI_GETCHARAT, nextPos)
            If nextChar=';'
               \Find\chrgText\cpMax+1
            EndIf
            
            \Original$=SciReadText()
            If \Original$ And auto & #Auto_Format
               \CharAdded=0
               SciAutoFormat()
               \LineEndPos+\CharAdded
            EndIf
            
            If nextChar<>#DoubleQuote And nextChar<>#SingleQuote : Break : EndIf
            
            If Not SciFindRegex(Chr(nextChar), nextPos+\CharAdded+1, \LineEndPos) : Break : EndIf
            \StartPos=\Find\chrgText\cpMax
            \EndPos=\LineEndPos
         Wend
         
         \WordCount=0
         \Original$=SciReadText(\Line)
         SciParseWords()
         SciParseLineBreakers()
         
         If auto & #Auto_Indent
            \CharAdded=0
            SciAutoIndent()
            \LineEndPos+\CharAdded
         EndIf
         If auto & #Auto_PositionCursor
            \CursorPos=\LineEndPos
            Sci(#SCI_GOTOPOS, \CursorPos)
         EndIf
         If auto & #Auto_TrimSpaces
            SciAutoTrimSpaces()
         EndIf
      EndWith
   EndProcedure
   
   Procedure SciFindLines(find)
      With App
         ;search for main line
         If find & #Find_CurrentLine
            \CursorPos = Sci(#SCI_GETCURRENTPOS)
            \CursorLine = Sci(#SCI_LINEFROMPOSITION, \CursorPos)
         EndIf
         
         ;search for extra lines
         If find & #Find_LastInsertedLines
            \FirstLine = Sci(#SCI_LINEFROMPOSITION, \InsertPos)
            \LastLine = \CursorLine-1
            
         ElseIf find & #Find_OnlyPreviousLine
            \FirstLine=\CursorLine-1
            \LastLine=\CursorLine-1
            
         ElseIf find & #Find_ClosestVisibleLines
            \FirstLine = Sci(#SCI_GETFIRSTVISIBLELINE)
            \LastLine=\CursorLine-1
            Protected visibleLine
            For visibleLine=\LastLine To \FirstLine Step -1
               If Not SCi(#SCI_GETLINEVISIBLE, visibleLine)
                  \FirstLine=visibleLine+1
                  Break
               EndIf
            Next
         EndIf
         ;search for broken lines before firstline
         If find & #Find_BrokenLines
            While \FirstLine>=0 And (SciFindRegex("[+,|]\s*$", \FirstLine) Or
                                     SciFindRegex("\<(and)\>\s*$", \FirstLine) Or
                                     SciFindRegex("\<(x?or)\>\s*$", \FirstLine))
               \FirstLine-1
            Wend
         EndIf
      EndWith
   EndProcedure
   Procedure SciBeautify(mode)
      With App
         Sci(#SCI_BEGINUNDOACTION)
         If mode & #Beautify_Comments
            ; ************************************
            ; beautify comments
            ; ************************************
            SciCurrentLine(\CursorLine)
            SciAutoComment()
         EndIf
         
         ; ************************************
         ; beautify previous lines
         ; ************************************
         Protected auto=0
         If mode & #Beautify_PreviousLines
            auto|#Auto_Format|#Auto_TrimSpaces
         EndIf
         If mode & #Beautify_Indentation
            auto|#Auto_Indent
            \IsBrokenLine=0
            \IsBrokenStartLine=0
            \BrokenIndent=0
            \BrokenStartIndent=0
         EndIf
         Protected previousLine
         For previousLine=\FirstLine To \LastLine
            SciCurrentLine(previousLine)
            SciParse(auto)
         Next
         ; ************************************
         ; beautify current line only
         ; ************************************
         SciCurrentLine(\CursorLine)
         \CursorPos=Sci(#SCI_GETCURRENTPOS)
         auto=#Auto_PositionCursor
         If mode & #Beautify_CurrentLine And \CursorPos>\LineIndentPos
            auto|#Auto_Format
         EndIf
         If mode & #Beautify_Indentation
            auto|#Auto_Indent
         EndIf
         SciParse(auto)
         
         
         Sci(#SCI_ENDUNDOACTION)
      EndWith
   EndProcedure
   Procedure SciBeautifyPaste()
      With App
         ; ************************************
         ; beautify pasted lines
         ; => format + trim + indent
         ; ************************************
         If \InsertLines>1
            SciFindLines(#Find_CurrentLine|
                         #Find_LastInsertedLines)
            SciBeautify(#Beautify_CurrentLine|
                        #Beautify_PreviousLines|
                        #Beautify_Indentation)
         EndIf
      EndWith
   EndProcedure
   Procedure SciBeautifyTyping(char)
      With App
         Select char
            Case #SPACE, #TAB
               ; ************************************
               ; beautify according to previous keyword
               ; => format + trim + indent
               ; ************************************
               SciFindLines(#Find_CurrentLine)
               SciCurrentLine(\CursorLine)
               If Sci(#SCI_GETSTYLEAT, \CursorPos-2)=2 And SciFindRegex("\w", \CursorPos-2, \CursorPos-1)
                  SciFindLines(#Find_ClosestVisibleLines)
                  SciBeautify(#Beautify_PreviousLines|
                              #Beautify_Indentation)
               EndIf
               
            Case #RETURN
               ; ************************************
               ; beautify closest visible lines
               ; => format + trim + indent
               ; ************************************
               SciFindLines(#Find_CurrentLine|#Find_ClosestVisibleLines)
               SciBeautify(#Beautify_Comments|
                           #Beautify_PreviousLines|
                           #Beautify_Indentation)
            Case'(', ')', ',', ':', '=', ';'
               ; ************************************
               ; beautify current line
               ; => format
               ; ************************************
               SciFindLines(#Find_CurrentLine)
               SciBeautify(#Beautify_CurrentLine)
         EndSelect
      EndWith
   EndProcedure
   Procedure SciHighlightWords()
      With App
         Static selStart, selEnd
         If selStart<>sci(#SCI_GETSELECTIONSTART) Or selEnd<>sci(#SCI_GETSELECTIONEND)
            selStart=sci(#SCI_GETSELECTIONSTART)
            selEnd=sci(#SCI_GETSELECTIONEND)
            Sci(#SCI_SETINDICATORCURRENT, 8)
            Sci(#SCI_INDICATORCLEARRANGE, 0, Sci(#SCI_GETTEXTLENGTH))
            If selStart<>selEnd
               Protected selText$=SciReadText(selStart, selEnd)
               Protected eof=Sci(#SCI_GETTEXTLENGTH)
               \find\chrgText\cpMin=0
               \find\chrgText\cpMax=eof
               While SciFindText(selText$)
                  sci(#SCI_INDICATORFILLRANGE, \find\chrgText\cpMin, \find\chrgText\cpMax-\find\chrgText\cpMin)
                  \find\chrgText\cpMin=\find\chrgText\cpMax
                  \find\chrgText\cpMax=eof
               Wend
            EndIf
         EndIf
      EndWith
   EndProcedure
   Procedure SciConfiguration()
      With App\SharedConfig
         Protected preferencesLastUpdate=GetProp_(App\Ide, "EXTEND_SharedConfig_Date")
         If GetProp_(App\Sci, "EXTEND_SharedConfig_Date")<preferencesLastUpdate
            SetProp_(App\Sci, "EXTEND_SharedConfig_Date", preferencesLastUpdate)
            
            ; *********************************************
            ; read shared tool preferences if it has been updated
            ; *********************************************
            If \MemoryMap=0
               \MemoryMap=AllocateMemory(SizeOf(PREFS))
            EndIf             
            If \Preferences\UdapteDate<preferencesLastUpdate
               \Name$="EXTEND_SharedConfig"
               \HandleMap = OpenFileMapping_(#FILE_MAP_ALL_ACCESS, 0, @\Name$)
               If \HandleMap
                  Protected *SharedMemoryMap=MapViewOfFile_(\HandleMap, #FILE_MAP_ALL_ACCESS, 0, 0, 0)                  
                  If *SharedMemoryMap
                     CopyMemory(*SharedMemoryMap,\MemoryMap,SizeOf(PREFS))                  
                     UnmapViewOfFile_(\MemoryMap)
                  EndIf 
                  CloseHandle_(\HandleMap)                
               EndIf
            EndIf 
            
            ; *********************************************
            ; make Cursor thicker
            ; *********************************************
            Sci(#SCI_SETCARETWIDTH, 3)
            
            ; *********************************************
            ; define custom indicator
            ; *********************************************
            Sci(#SCI_INDICSETSTYLE, 8, #INDIC_ROUNDBOX)
            Sci(#SCI_INDICSETUNDER, 8, #True)
            Sci(#SCI_INDICSETALPHA, 8, 100)
            Sci(#SCI_INDICSETOUTLINEALPHA, 8, 150)
            Sci(#SCI_INDICSETFORE, 8, \Preferences\HighlightColor)
            
         EndIf
      EndWith
   EndProcedure   
   Procedure SciCallback(code, *notify.SCNotification)
      With App
         SciConfiguration()
               
         Select code
            Case #SCN_UPDATEUI
               SciHighlightWords()
            Case #SCN_CHARADDED
               SciBeautifyTyping(*notify\ch)
            Case #SCN_MODIFIED
               If *notify\modificationType & #SC_MOD_INSERTTEXT And
                  *notify\modificationType & #SC_PERFORMED_USER
                  \InsertPos=*notify\position
                  \InsertLines=*notify\linesAdded
               EndIf
            Case #SCN_DOUBLECLICK
               
         EndSelect
      EndWith
   EndProcedure
      
   ProcedureDLL WndProc(nCode, wParam, lParam)
      With App
         If nCode=#HC_ACTION
            Protected *cwp.CWPRETSTRUCT=lParam
            Protected *notify.NMHDR = *cwp\lParam
            Protected lw=*cwp\wParam & $FFFF
            Protected hi=*cwp\wParam >> 16
            
            If *cwp\message=#WM_NOTIFY And GetProp_(*notify\hwndFrom, "EXTEND_Scintilla")
               \Sci=*notify\hwndFrom
               \Tool=GetProp_(*cwp\hWnd, "EXTEND_Tool")
               \Ide=*cwp\hWnd
               SciCallback(*notify\code, *notify)
            EndIf
            
            If *cwp\hWnd=\Sci
               If *cwp\message=#SCI_PASTE
                  SciBeautifyPaste()
               ElseIf *cwp\message=#SCI_SETSEL Or
                      *cwp\message=#SCI_MOVECARETINSIDEVIEW Or
                      *cwp\message=#SCI_SETEMPTYSELECTION Or
                      *cwp\message=#SCI_SCROLLCARET Or
                      *cwp\message=#SCI_GOTOPOS
                  ;test
               ElseIf *cwp\message=#SCI_TAB
                  ;test
               EndIf
            EndIf
            
            If *cwp\hWnd=\Ide
               If *cwp\message=#WM_DESTROY And IsWindow_(\Tool)
                  PostMessage_(App\Tool, #WM_CLOSE, 0, 0)
               ElseIf *cwp\message=#WM_COMMAND
                  ;test
               EndIf
            EndIf
         EndIf
         ProcedureReturn CallNextHookEx_(#Null, nCode, wParam, lParam)
      EndWith
   EndProcedure
   
CompilerElse
   Procedure.b LoadParameters()
      With App
         \Ide=Val(GetEnvironmentVariable("PB_TOOL_MainWindow"))
         \Sci=Val(GetEnvironmentVariable("PB_TOOL_Scintilla"))
         ProcedureReturn Bool(\Ide And \Sci)
      EndWith
   EndProcedure
   Procedure.b OpenHookup()
      With App
         SetProp_(\Sci, "EXTEND_Scintilla", 1)
         If GetProp_(\Ide, "EXTEND_Tool")=0
            SetProp_(\Ide, "EXTEND_Tool", 1)
            \Dll=OpenLibrary(0, "pb_editor_extension.dll")
            \WndProc=GetFunction(0, "WndProc")
            \Hook=SetWindowsHookEx_(#WH_CALLWNDPROCRET, \WndProc, \Dll, GetWindowThreadProcessId_(\Ide, 0))
            \Tool=OpenWindow(1, 10, 10, 400, 300, "PB Editor Extensions", #PB_Window_SystemMenu|
                                                                          #PB_Window_MinimizeGadget|
                                                                          #PB_Window_ScreenCentered|
                                                                          #PB_Window_Minimize|
                                                                          #PB_Window_NoActivate)
            SetProp_(\Ide, "EXTEND_Tool", \Tool)
         EndIf
         ProcedureReturn Bool(\Dll And \WndProc And \Hook)
      EndWith
   EndProcedure
   Procedure.b OpenFileConfig()
      With App\SharedConfig
         ; *********************************************
         ; read ini file and share tool preferences
         ; *********************************************
         \File$=ReplaceString(#PB_Compiler_File, ".pb", ".ini")
         If OpenPreferences(\File$, #PB_Preference_GroupSeparator) Or CreatePreferences(\File$, #PB_Preference_GroupSeparator)
            \Name$="EXTEND_SharedConfig"
            \HandleMap = CreateFileMapping_(#INVALID_HANDLE_VALUE, 0, #PAGE_READWRITE|#SEC_COMMIT|#SEC_NOCACHE, 0, SizeOf(PREFS), @\Name$)
            If \HandleMap
               \MemoryMap=MapViewOfFile_(\HandleMap, #FILE_MAP_ALL_ACCESS, 0, 0, 0)
               
               \Preferences\Commas=ReadPreferenceInteger("Commas",1)
               \Preferences\Colons=ReadPreferenceInteger("Colons",1)
               \Preferences\Equals=ReadPreferenceInteger("Equals",1)
               \Preferences\Comparisons=ReadPreferenceInteger("Comparisons",1)
               
               \Preferences\UseThickerCaret=ReadPreferenceInteger("UseThickerCaret",1)
               \Preferences\UseCommentHelper=ReadPreferenceInteger("UseCommentHelper",1)
               \Preferences\UseWordHighlighting=ReadPreferenceInteger("UseWordHighlighting",1)
               \Preferences\CommentBarLength=ReadPreferenceInteger("CommentBarLength",20)
               \Preferences\HighlightColor=ReadPreferenceInteger("HighlightColor",RGB(252, 255, 177))
               
               \Preferences\UdapteDate=Date()
               SetProp_(App\Ide, "EXTEND_SharedConfig_Date", \Preferences\UdapteDate)
            EndIf         
            ClosePreferences()            
            ProcedureReturn Bool(\MemoryMap)
         EndIf 
      EndWith
   EndProcedure  
   Procedure CloseHookup()
      With App
         If \Hook
            SetProp_(\Ide, "EXTEND_Tool", 0)
            UnhookWindowsHookEx_(\Hook)
            CloseLibrary(0)
         EndIf
      EndWith
   EndProcedure
   Procedure CloseFileConfig()
      With App\SharedConfig
         UnmapViewOfFile_(\MemoryMap)
         CloseHandle_(\HandleMap)
      EndWith
   EndProcedure
   Procedure RunApp()
      With App
         If LoadParameters() And OpenHookup() And OpenFileConfig()
            
            ; ********************
            ; form gadgets
            ; ********************
            Protected panelSpacings, cbComma, cbColon, cbEqual, cbOperator, btOK
            panelSpacings = PanelGadget(#PB_Any, 10, 10, 380, 250)
            AddGadgetItem(panelSpacings, -1, "Spacings")
            cbComma = CheckBoxGadget(#PB_Any, 10, 2, 220, 25, "commas a, b")
            cbColon = CheckBoxGadget(#PB_Any, 10, 22, 220, 25, "colons a : b")
            cbEqual = CheckBoxGadget(#PB_Any, 10, 42, 220, 25, "equals a = b")
            cbOperator = CheckBoxGadget(#PB_Any, 10, 62, 220, 25, "comparisons a <= b")
            AddGadgetItem(panelSpacings, -1, "Helpers")
            CloseGadgetList()
            btOK = ButtonGadget(#PB_Any, 290, 264, 100, 25, "OK")
            
            ; ********************
            ; form event loop
            ; ********************
            Repeat
               Protected event=WaitWindowEvent()
               Select event
                  Case #PB_Event_Gadget
                     Select EventGadget()
                           Case btOK : Break
                     EndSelect                      
                  Case #PB_Event_CloseWindow
                     Break
               EndSelect
            ForEver
            CloseHookup()
            CloseFileConfig()
            End
         EndIf 
      EndWith
   EndProcedure
   
   RunApp()
CompilerEndIf
; IDE Options = PureBasic 5.11 beta 3 (Windows - x64)
; CursorPosition = 800
; FirstLine = 52
; Folding = BAAAAh5
; EnableXP